MappedByteBuffer (Java Platform SE 8 )
Keywords: java.nio.MappedByteBuffer class
Date: 2026-04-17

compact1, compact2, compact3
java.nio

## Class MappedByteBuffer

- java.lang.Object
- - java.nio.Buffer
  - - java.nio.ByteBuffer
    - - java.nio.MappedByteBuffer

- All Implemented Interfaces:
    Comparable<ByteBuffer>

      public abstract class MappedByteBuffer
      extends ByteBuffer

  A direct byte buffer whose content is a memory-mapped region of a file.

  Mapped byte buffers are created via the `FileChannel.map` method. This class extends the `ByteBuffer` class with operations that are specific to memory-mapped file regions.

  A mapped byte buffer and the file mapping that it represents remain valid until the buffer itself is garbage-collected.

  The content of a mapped byte buffer can change at any time, for example if the content of the corresponding region of the mapped file is changed by this program or another. Whether or not such changes occur, and when they occur, is operating-system dependent and therefore unspecified.

  All or part of a mapped byte buffer may become inaccessible at any time, for example if the mapped file is truncated. An attempt to access an inaccessible region of a mapped byte buffer will not change the buffer's content and will cause an unspecified exception to be thrown either at the time of the access or at some later time. It is therefore strongly recommended that appropriate precautions be taken to avoid the manipulation of a mapped file by this program, or by a concurrently running program, except to read or write the file's content.

  Mapped byte buffers otherwise behave no differently than ordinary direct byte buffers.

  Since:
    1.4

- - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `MappedByteBuffer` | `force()` Forces any changes made to this buffer's content to be written to the storage device containing the mapped file.
    `boolean` | `isLoaded()` Tells whether or not this buffer's content is resident in physical memory.
    `MappedByteBuffer` | `load()` Loads this buffer's content into physical memory.

    - ### Methods inherited from class java.nio.ByteBuffer

      `allocate, allocateDirect, array, arrayOffset, asCharBuffer, asDoubleBuffer, asFloatBuffer, asIntBuffer, asLongBuffer, asReadOnlyBuffer, asShortBuffer, compact, compareTo, duplicate, equals, get, get, get, get, getChar, getChar, getDouble, getDouble, getFloat, getFloat, getInt, getInt, getLong, getLong, getShort, getShort, hasArray, hashCode, isDirect, order, order, put, put, put, put, put, putChar, putChar, putDouble, putDouble, putFloat, putFloat, putInt, putInt, putLong, putLong, putShort, putShort, slice, toString, wrap, wrap`

    - ### Methods inherited from class java.nio.Buffer

      `capacity, clear, flip, hasRemaining, isReadOnly, limit, limit, mark, position, position, remaining, reset, rewind`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### isLoaded

          public final boolean isLoaded()

      Tells whether or not this buffer's content is resident in physical memory.

      A return value of `true` implies that it is highly likely that all of the data in this buffer is resident in physical memory and may therefore be accessed without incurring any virtual-memory page faults or I/O operations. A return value of `false` does not necessarily imply that the buffer's content is not resident in physical memory.

      The returned value is a hint, rather than a guarantee, because the underlying operating system may have paged out some of the buffer's data by the time that an invocation of this method returns.

      Returns:
        `true` if it is likely that this buffer's content is resident in physical memory

    - #### load

          public final MappedByteBuffer load()

      Loads this buffer's content into physical memory.

      This method makes a best effort to ensure that, when it returns, this buffer's content is resident in physical memory. Invoking this method may cause some number of page faults and I/O operations to occur.

      Returns:
        This buffer

    - #### force

          public final MappedByteBuffer force()

      Forces any changes made to this buffer's content to be written to the storage device containing the mapped file.

      If the file mapped into this buffer resides on a local storage device then when this method returns it is guaranteed that all changes made to the buffer since it was created, or since this method was last invoked, will have been written to that device.

      If the file does not reside on a local device then no such guarantee is made.

      If this buffer was not mapped in read/write mode (`FileChannel.MapMode.READ_WRITE`) then invoking this method has no effect.

      Returns:
        This buffer

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.